import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import arb.soundcipher.*; 
import java.io.File; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class chroma_loops_smaller extends PApplet {

// Written and designed by Aleksandar Ma\u0107a\u0161ev for Chromapost
// It's not nice to steal other people's shit, so contact me if you would like to use the code.




SoundCipher sc = new SoundCipher(this);



// ============= reduction


float redu = 30;
float redu2= 2*redu;

// ============= margins
float shiftx = 40;
float shifty = 40;
float shiftm = 50;

// ============= pie segments

int num; // number of segments
float rad=350; //radius of the whole pie
int [] fields;
int [] fieldso;
int what; //number of the clicked segment
float cpie=rad+shiftx; // center of the pie

float res, finalres; // getting segment's number

int white, black, gray1, gray2, black2; // various constant colors
int pick; //picked color
int picko; // picked outline

int whatmarker;

int pickpick; // picked color when click on a colored segment

boolean segmenton;


// ============ swatches

PImage img; // image
float markx, marky; // swatches marker
float re, gr, bl; // rgb of the picked color
float rgb; // grayscale value of picked color

int [] allcolors = new int [180];


// =========== controls
PImage cont;
PImage editimg;
PFont font;
int [] numseg={2, 4, 6, 8, 12, 15, 18, 20, 24, 30, 36, 40, 45}; // possible numbers of segments
int numcount; // counting + - for the number of segments

boolean edit;
int editcount;
float editx, edity;



boolean check=false;

PImage pause; // pause button
float pausex, pausey; // coordinates of pause button
int play; // play switch


boolean swatcheson;
boolean photoon;
// button dimmer
float buttx, butty;
// load photo mask
float loadpx, loadpy;
// swatches position
float swx, swy;



// ================ music

float low=21; //lowest pitch
float high=108; //highest pitch
int playcolor; // played color
float rr, gg, bb; // rgb of the played color
float rrr, ggg, bbb; // pitches
int tempo;

float xcol, ycol; // cartesian coordinates of pick from color
int countnum;

float ang; // piece of pie
float ang2; // half of piece of pie
float rad2=300; // radius for picking color

int tempocount;

int [] tempoval= { 17, 15, 13, 11, 9, 7, 5};


// =================== photo

PImage photo;

int photopick1, photopick2;
float phs1=5;
float phs2=25;

// photo origin
float photoorx = (2*rad)+(2*shiftx);
float photoory = shifty;


// main image dimensions and ratio
float imw;
float imh;
float rat; // image ratio
float ratm=1.5f; // main ratio 3:2


PImage load;
PImage footer;
PImage rest;
PImage swatchesp;


int maincounter; // counting all the frames
int markerframes; // angle to move marker by one frame. number of frames for the full circle







// ===================== SETUP

public void setup(){
 
  
  
  numcount=4;
  num=numseg[numcount];
  
  fields = new int[num]; // fill color for each field
  fieldso = new int [num]; // outline color of segments
  
  
  white=color(255); // white
  black=color(0); // black
  gray1=color(230);
  gray2=color(50);
  black2=color(20);
  
  
  for(int x=0; x<num; x++){
    
   fields[x]=black2; 
   fieldso[x]=gray2;
  }
  
  //img=loadImage("swatches9279.png");
  cont=loadImage("controls.png");
  editimg=loadImage("edit.png");
  

  
  markx=-100;
  marky=-100;
  
  
  what=-1;
  
  font = loadFont("Gotham-Book-12.vlw");
  textFont(font);
  textSize(12);
  
  editcount=3;
  edit=false;
  
  
  
  background(black);
 
  
  
  for(int y=0; y<36; y++){
    for(int x=0; x<5; x++){
      
    allcolors[(y*5)+x]=get(PApplet.parseInt(((shiftx*2)+(rad*2))+(x*45)+5), PApplet.parseInt(shifty+(y*15)+5));
      
      
      
    }
    
  }
  
pause=loadImage("pause.png");  
footer=loadImage("footer.png"); 
pausex=-500;
pausey=-500;
play=3;
tempo=tempoval[1];  
tempocount=5;
  
  
load=loadImage("load.png");
rest=loadImage("rest.png");
swatchesp=loadImage("swatches.png");

maincounter=0;
//markerframes=360/(num*3*tempo);

swatcheson=true;
photoon=false;
buttx=1000-redu2; // mask for buttons
butty=853-redu2;
loadpx=899-redu2; // mask for load photo
loadpy=853-redu2;

// swatches position
swx=840-redu2;
swy=shifty;

}



// ===================== END SETUP





// ===================== DRAW


public void draw(){
  background(black);
 
  num=numseg[numcount];
  
  
  
 // filling based on picked color
 
 for(int x=0; x<num; x++){
 if(x==what){
 fields[x]=pick;
 fieldso[x]=picko;
 }

 }

 

 
 
  
 //  pie 
 for(int x=0; x<num; x++){

  
  
  pushMatrix();
  translate(cpie, cpie);  
    
  rotate((TWO_PI/num)*x);
  fill(fields[x]);
  strokeWeight(2);
  stroke(fieldso[x]);
  arc(0, 0, rad*2, rad*2, 0, TWO_PI/num, PIE);
  
  popMatrix();
  
  }
  
  // center
  fill(0);
  //stroke(white);
  noStroke();
  ellipse(cpie, cpie, 150, 150);
  
  if(what==-1){
    
   whatmarker=0; 
  }
  else{
    whatmarker=what;
  }
  
  // pie marker
  pushMatrix();
  translate(cpie, cpie); 
  rotate(((TWO_PI/num)*whatmarker)+((TWO_PI/num)/2));
  noStroke();
  fill(180);
  ellipse( 65, 0, 5, 5);
  
  
  popMatrix();
  
  
  //  swatches no swatches
  //image(img, (shiftx*2)+(rad*2), shifty);  
  
  // photo
  // main photo
  
  // formating the image  
 if (photo!=null) { // only of the image is selected
 
    // calculating based on ratio 3:2, 0.66
    imw=photo.width;
    imh=photo.height;
    rat=imw/imh;
    
    // if loaded image is exactly 3:2
    if(rat==ratm){
    image(photo, photoorx, photoory, 225, 150);  
    }
    
    // if loaded image is towards square or portrait
    if(rat<ratm){
    int iw=225; // width is 225
    int ih=PApplet.parseInt(iw/rat); // sizing the height proportionally
    int dif = PApplet.parseInt((ih-150)/2); //center the photo
    image(photo, photoorx, photoory-dif, iw, ih);
    }
    
    //if loaded image is wider than 4:3
    if(rat>ratm){
    int ih=150; // height is 150  
    int iw=PApplet.parseInt(ih*rat);
    int dif = PApplet.parseInt((iw-225)/2); // center the photo
    image(photo, photoorx-dif, photoory, iw, ih);
    }
    
 }
 
 // =============== masks
 

 noStroke();
 fill(0);
 
  //top
 rect(745, 0, width-500, shifty);
 //left
 rect(721, 0, 59, 228);
 // right
 rect(1065-redu2, 0, shiftx*2, 228);
 //bottom
 rect(800-redu2, 220-redu, 450, 100);
 
 
  
  
  
 // 2nd photo
  
  copy(PApplet.parseInt(840-redu2), PApplet.parseInt(shifty), 225, 150, PApplet.parseInt((shiftx*2)+(rad*2)), PApplet.parseInt(shifty+175), 225, 150);
  for(int j=0; j< 150/phs1; j++){
    for(int i=0; i< 225/phs1; i++){
    photopick1=get(PApplet.parseInt((shiftx*2)+(rad*2)+(i*phs1)+(phs1*0.5f)), PApplet.parseInt((j*phs1)+(phs1*0.5f)+(shifty+175)));
    fill(photopick1);
    noStroke();
    rect((i*phs1)+(shiftx*2)+(rad*2), (j*phs1)+(shifty+175), phs1, phs1);
      
    }
  }
  
  
  // 3d photo
  
  copy(PApplet.parseInt(840-redu2), PApplet.parseInt(shifty), 225, 150, PApplet.parseInt((shiftx*2)+(rad*2)), PApplet.parseInt(shifty+350), 225, 150);
  
  for(int j=0; j< 150/phs2; j++){
    for(int i=0; i<225/phs2; i++){
    photopick2=get(PApplet.parseInt((shiftx*2)+(rad*2)+(i*phs2)+(phs2*0.5f)), PApplet.parseInt((j*phs2)+(phs2*0.5f)+shifty+350));
    fill(photopick2);
    noStroke();
    rect((i*phs2)+(shiftx*2)+(rad*2), (j*phs2)+shifty+350, phs2, phs2);
      
    }
  }
  
  
  // swatches
  
  if(photoon==true){
   swx=-500;
   swy=-1000;    
  }
  if(swatcheson==true){
   swx=840-redu2;
   swy=shifty;    
  }
  
  image(swatchesp, swx, swy);
  
  
  
  
  // controls
  image(cont, 840-redu2, 745-redu);
  
  fill(150);
  textAlign(CENTER);
  text(str(num), 882-redu2, 762-redu);
  
  
  //image(load, 840, 645);
  
  // play/pause buttons
  image(pause, pausex, pausey);
  
  image(footer, 0, 840-redu2);
  if( (photo!=null && photoon==true) || swatcheson==true ){
  image(rest, 1040-redu2, 595-redu);
  }
  
  
  // tempo
  
  for(int x=0; x<tempocount; x++){
  fill(166, 166, 166);
  noStroke();
  rect(947+(x*10)-redu2, 745-redu, 8, 25);
  }
  
  tempo=tempoval[tempocount-1];
  
  // ======== music

// pick colors from the circle



if(play%2==0){
  
  ang=TWO_PI/num;
  ang2=ang/2;
  
  
  
  
  
  if(frameCount%tempo==0){
   
   xcol = (rad2*cos((ang2 + (ang * floor(countnum/3))))) + cpie;
   ycol = (rad2*sin((ang2 + (ang * floor(countnum/3))))) + cpie;
   
   //ellipse(xcol, ycol, 20, 20);
   
   playcolor=get(PApplet.parseInt(xcol), PApplet.parseInt(ycol));
   rr=red(playcolor);
   gg=green(playcolor);
   bb=blue(playcolor);
   
   rrr=map(rr, 0, 255, low, high);
   ggg=map(gg, 0, 255, low, high);
   bbb=map(bb, 0, 255, low, high);
   
   if(playcolor==black){
    rrr=0;
    ggg=0;
    bbb=0;
     
   }
   
   if(countnum%3==0){
    sc.playNote(rrr, 100, 1.0f);  
    //println("r" + " " + rrr);
   }
   if(countnum%3==1){
    sc.playNote(ggg, 100, 1.0f);  
    //println("g" + " " + ggg);
   }
   if(countnum%3==2){
    sc.playNote(bbb, 100, 1.0f);  
    //println("b" + " " + bbb);
   }
   
   

  
countnum=countnum+1; 

if(countnum==num*3){
 countnum=0; 
}
  
}


}
 
  // play marker
  if(play%2==0){
pushMatrix();
translate(cpie, cpie);


rotate(radians(90)+(floor(countnum)*(ang/3))-(ang/3));


stroke(100);
strokeWeight(7);
strokeCap(SQUARE);
noFill();
arc(0, 0, (2*rad)+20, (2*rad)+20, radians(270), radians(270)+(ang/3));

popMatrix();

  }
  
  
  // footer control masks
  
  
  if(photoon==true){
   buttx=1040-redu2;
   butty=853-redu2;
   loadpx=-200;
   loadpy=-200;
  }
  if(swatcheson==true){
   buttx=1000-redu2;
   butty=853-redu2;
   loadpx=899-redu2;
   loadpy=853-redu2;
  }
  noStroke();
  fill(30, 30, 30, 150);
  rect(buttx, butty, 25, 25);
  
  fill(30, 30, 30);
  rect(loadpx, loadpy, 86, 25);
  
  
// cursor for photos
if( photo!=null && photoon==true ){

if(((mouseX>840-redu2 && mouseX<1065-redu2) && (mouseY>shifty && mouseY <220-redu)) || ((mouseX>840-redu2 && mouseX<1065-redu2) && (mouseY>245-redu && mouseY <395-redu)) 
|| ((mouseX>840-redu2 && mouseX<1065-redu2) && (mouseY>420-redu && mouseY <570-redu)) || ((mouseX>1040-redu2 && mouseX<1040+25-redu2) && (mouseY>595-redu && mouseY <595+25-redu))){
  
 cursor(CROSS); 
  
}
else
{
  
 cursor(ARROW); 
}
}

// cursor for swatches
if( swatcheson==true ){

if(((mouseX>840-redu2 && mouseX<1065-redu2) && (mouseY>shifty && mouseY <570-redu)) || ((mouseX>1040-redu2 && mouseX<1040+25-redu2) && (mouseY>595-redu && mouseY <595+25-redu))){
  
 cursor(CROSS); 
  
}
else
{
  
 cursor(ARROW); 
}
}



}


// ===================== END DRAW








// ===================== MOUSE PRESSED


public void mousePressed(){

  
  
  
  // fields actions w segments
  
  if(dist(cpie, cpie, mouseX, mouseY) < rad){
    
    segmenton=true;
    
   res=degrees(atan2(mouseY-cpie, mouseX-cpie)); 
   
   if(res==360){
     res=0;
   }
   
   
   if(res>=0){
   finalres=res;
 }
 else
 {
   finalres=360+res;
 } 
 
 
 what=floor(finalres/(360/num)); // number of the segment
 
 
 //if(what==-1){
 // fieldso[what]=gray2; 
   
   
   
 //}
 
 
 //if clicked on the segment keep the color
 pickpick=get(mouseX, mouseY);
 if(pickpick==black2){
   pick=black2;
   picko=gray2;
 }
 else
 {  
 pick=pickpick;
 picko=pickpick;
 }
 
 
 
 // move swatch marker according to the segment click // NOT IN THIS VERSION
 
 // colors except black and black2
 for(int j=0; j<180; j++){
  if(allcolors[j] == pickpick){
   
   markx=((j%5)*45)+21+(shiftx*2)+(rad*2);
   marky=((floor(j/5))*15)+6+shifty;
   
  }
 }
 
 //black 2
 if(pickpick==black2){
  markx=-500;
  marky=-500;
   
 }
 
 // black
 if(pickpick==black){
  markx = (2*shiftx)+(2*rad)+180+21;
 marky = shifty+540+15 +6; 
   
 }
 
 
 
  
}



 // photo action
 if( photo!=null && photoon==true ){
 
 if(((mouseX>840-redu2 && mouseX<1065-redu2) && (mouseY>shifty && mouseY <220-redu)) || ((mouseX>840-redu2 && mouseX<1065-redu2) && (mouseY>245-redu && mouseY <395-redu)) 
 || ((mouseX>840-redu2 && mouseX<1065-redu2) && (mouseY>420-redu && mouseY <570-redu))  ){
   
   pick=get(mouseX, mouseY);
  picko=get(mouseX, mouseY); 
  
  if(edit==false){
  what=what+1;
  if(what==num){
    
   what=0; 
  }
  }
  else
  {
   what=what; 
  }
  
  //correction
  
  if(segmenton==true && edit==false){  
    what=what-1;  
    
    if(what==-1){
     what=num-1; 
    }
    segmenton=false;
  }

 }

 } 
 
 
 // swatches action
 if( swatcheson==true ){
 
 if((mouseX>840-redu2 && mouseX<1065-redu2) && (mouseY>shifty && mouseY <570-redu)){
   
   pick=get(mouseX, mouseY);
  picko=get(mouseX, mouseY); 
   
  
  if(edit==false){
  what=what+1;
  if(what==num){
    
   what=0; 
  }
  }
  else
  {
   what=what; 
  }
  
  //correction
  
  if(segmenton==true && edit==false){  
    what=what-1;  
    
    if(what==-1){
     what=num-1; 
    }
    segmenton=false;
  }

 }
 
 }
 
 
 // rest actions
 
 
 
 if(( photo!=null && photoon==true ) || swatcheson==true ){
 
   if(((mouseX>1040-redu2 && mouseX<1040+25-redu2) && (mouseY>595-redu && mouseY <595+25-redu))){ // rest
  pick=black;
  picko=black; 
  
  
  if(edit==false){
  what=what+1;
  if(what==num){
    
   what=0; 
  }
  }
  else
  {
   what=what; 
  }
  
  //correction
  
  if(segmenton==true && edit==false){  
    what=what-1;  
    
    if(what==-1){
     what=num-1; 
    }
    segmenton=false;
  }
  

  }

 }
 
 
 
 
 
// minus 
 if ((mouseX>840-redu2 && mouseY >745-redu) && (mouseX<840+25-redu2 && mouseY <745+25-redu)){
 numcount=numcount-1;
 if(numcount==-1){   
  numcount=0; 
 }
 
what=-1;
 
 num=numseg[numcount];
 
  fields = new int[num]; // fill color for each field
  fieldso = new int [num];
  
  for(int x=0; x<num; x++){
    
   fields[x]=black2; 
   fieldso[x]=gray2;
  }
  
  
  markx = -500;
 marky = -500;
 countnum=0;
 
 }
 
 //plus
 if ((mouseX>840+58-redu2 && mouseY >745-redu) && (mouseX<840+58+25-redu2 &&  mouseY<745+25-redu)){
 numcount=numcount+1;
 if(numcount==13){   
  numcount=12; 
 }
 
what=-1;
 
 num=numseg[numcount];
 
  fields = new int[num]; // fill color for each field
  fieldso = new int [num];
  
  for(int x=0; x<num; x++){
    
   fields[x]=black2; 
   fieldso[x]=gray2;
  }
  
  
  markx = -500;
 marky = - 500;
  countnum=0;

 }
 
  
  
  
  // play

  if ((mouseX>1040-redu2 && mouseY >745-redu) && (mouseX<1065-redu2 &&  mouseY<745+25-redu)){
   play=play+1; 
   
    if(play%2==0){
     pausex=1040-redu2;
     pausey=745-redu;

    }
    
    
    if(play%2==1){
     pausex=-500;
     pausey=-500;

    }
  }
  
  
  //tempo
  
  if ((mouseX>947-redu2 && mouseY >745-redu) && (mouseX<1015-redu2 &&  mouseY<745+25-redu)){
    for(int x=0; x<7; x++){
    if(mouseX>947+(x*10)-redu2 && mouseX<947+(x*10)+10-redu){
    tempocount=x+1;
    }
    }
    
    //println(tempocount);
    
  }
  
  
  //load
   if ((mouseX>899-redu2 && mouseY >853-redu2) && (mouseX<985-redu2 &&  mouseY<878-redu2)){
     if (photoon==true){
  
   chooseFolder(); 
   
     }
  
   }
   
   
   
   // photo mode is on   
   if((mouseX>1000-redu2 && mouseX<1025-redu2) && (mouseY>853-redu2 && mouseY<878-redu2)){
    photoon=true;
    swatcheson=false;
   }
   
   
      // swatches mode is on   
   if((mouseX>1040-redu2 && mouseX<1065-redu2) && (mouseY>853-redu2 && mouseY<878-redu2)){
    photoon=false;
    swatcheson=true;
   }

 } // ============== END OF MOUSE PRESSED
 
 
 
 // loading photo
public void chooseFolder() {
  File folderToStartFrom = new File( "D://*.*" );
  selectInput("Select an image ", "folderSelected", folderToStartFrom );
}
//
public void folderSelected(File selection) {
  // this runs in another thread parallel to the main thread
  if (selection == null) {
    println("Window was closed or Load Image was cancelled.");
  }
  else {
    println("You selected " + selection.getAbsolutePath());
    photo=loadImage(  selection.getAbsolutePath()   );
  }
}
 
 
 
 
 
 public void keyPressed(){
  if(key=='l'){ 
   
   chooseFolder();
   
   
  }
 }
 
 
 public void mouseReleased(){
   // load

   
   
 }
  public void settings() {  size(1045, 830); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "chroma_loops_smaller" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
